////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Unit Name : uDebugCoreTest
//  * Purpose   :     
//  * Author    :  (Rouse_) 
//  * Copyright :  Fangorn Wizards Lab 1998 - 2012.
//  * Version   : 1.0
//  * Home Page : http://rouse.drkb.ru
//  * Home Blog : http://alexander-bagel.blogspot.com/
//  ****************************************************************************
//

unit uDebugCoreTest;

interface

uses
  Windows, Classes, Controls, Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    btnDebugString: TButton;
    btnExcept: TButton;
    btnKillStack: TButton;
    procedure btnExceptClick(Sender: TObject);
    procedure btnDebugStringClick(Sender: TObject);
    procedure btnKillStackClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//
//    
// =============================================================================
procedure TForm1.btnDebugStringClick(Sender: TObject);
begin
  OutputDebugString('Test debug string');
end;

//
//       
// =============================================================================
procedure TForm1.btnExceptClick(Sender: TObject);
begin
  try
    asm
      int 3
    end;
    ShowMessage('Debugger detected.');
  except
    ShowMessage('Debugger not found.');
  end;
end;

//
//      
// =============================================================================
procedure TForm1.btnKillStackClick(Sender: TObject);
 
  procedure T;
  var
    HugeBuff: array [0..10000] of DWORD;
  begin
    if HugeBuff[0] <> HugeBuff[10000] then
      Inc(HugeBuff[0]);
    T;
  end;
 
begin
  try
    T;
  except
    T;
  end;
end;

end.
